Query and filter for commitments. - m3ter Documentation

Query and filter for commitments.

cURL

curl --request POST \
  --url https://api.m3ter.com/organizations/{orgId}/dataexplorer/commitments/v2 \
  --header 'Authorization: Bearer <token>' \
  --header 'Content-Type: application/json' \
  --data '
{
  "startDate": "2023-11-07T05:31:56Z",
  "endDate": "2023-11-07T05:31:56Z",
  "dimensions": [
    {
      "name": "<string>",
      "filter": [
        "<string>"
      ],
      "attributes": [
        "<string>"
      ]
    }
  ],
  "limit": 1000
}
'

Python

import requests

url = "https://api.m3ter.com/organizations/{orgId}/dataexplorer/commitments/v2"

payload = {
    "startDate": "2023-11-07T05:31:56Z",
    "endDate": "2023-11-07T05:31:56Z",
    "dimensions": [
        {
            "name": "<string>",
            "filter": ["<string>"],
            "attributes": ["<string>"]
        }
    ],
    "limit": 1000
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.text)

JavaScript (Fetch)

const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: JSON.stringify({
    startDate: '2023-11-07T05:31:56Z',
    endDate: '2023-11-07T05:31:56Z',
    dimensions: [{name: '<string>', filter: ['<string>'], attributes: ['<string>']}],
    limit: 1000
  })
};

fetch('https://api.m3ter.com/organizations/{orgId}/dataexplorer/commitments/v2', options)
  .then(res => res.json())
  .then(res => console.log(res))
  .catch(err => console.error(err));

PHP

$curl = curl_init();

curl_setopt_array($curl, [
  CURLOPT_URL => "https://api.m3ter.com/organizations/{orgId}/dataexplorer/commitments/v2",
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => "",
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 30,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => "POST",
  CURLOPT_POSTFIELDS => json_encode([
    'startDate' => '2023-11-07T05:31:56Z',
    'endDate' => '2023-11-07T05:31:56Z',
    'dimensions' => [[
            'name' => '<string>',
            'filter' => ['<string>'],
            'attributes' => ['<string>']
        ]
    ],
    'limit' => 1000
  ]),
  CURLOPT_HTTPHEADER => [
    "Authorization: Bearer <token>",
    "Content-Type: application/json"
  ],
]);

$response = curl_exec($curl);
$err = curl_error($curl);

curl_close($curl);

if ($err) {
  echo "cURL Error #:" . $err;
} else {
  echo $response;
}

Go

package main

import (
    "fmt"
    "strings"
    "net/http"
    "io"
)

func main() {

url := "https://api.m3ter.com/organizations/{orgId}/dataexplorer/commitments/v2"

payload := strings.NewReader("{\n  \"startDate\": \"2023-11-07T05:31:56Z\",\n  \"endDate\": \"2023-11-07T05:31:56Z\",\n  \"dimensions\": [\n    {\n      \"name\": \"<string>\",\n      \"filter\": [\n        \"<string>\"\n      ],\n      \"attributes\": [\n        \"<string>\"\n      ]\n    }\n  ],\n  \"limit\": 1000\n}")

req, _ := http.NewRequest("POST", url, payload)

req.Header.Add("Authorization", "Bearer <token>")
    req.Header.Add("Content-Type", "application/json")

res, _ := http.DefaultClient.Do(req)

defer res.Body.Close()
    body, _ := io.ReadAll(res.Body)

fmt.Println(string(body))
}

Unirest

HttpResponse<String> response = Unirest.post("https://api.m3ter.com/organizations/{orgId}/dataexplorer/commitments/v2")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"startDate\": \"2023-11-07T05:31:56Z\",\n  \"endDate\": \"2023-11-07T05:31:56Z\",\n  \"dimensions\": [\n    {\n      \"name\": \"<string>\",\n      \"filter\": [\n        \"<string>\"\n      ],\n      \"attributes\": [\n        \"<string>\"\n      ]\n    }\n  ],\n  \"limit\": 1000\n}")
  .asString();

Ruby

require 'uri'
require 'net/http'

url = URI("https://api.m3ter.com/organizations/{orgId}/dataexplorer/commitments/v2")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"startDate\": \"2023-11-07T05:31:56Z\",\n  \"endDate\": \"2023-11-07T05:31:56Z\",\n  \"dimensions\": [\n    {\n      \"name\": \"<string>\",\n      \"filter\": [\n        \"<string>\"\n      ],\n      \"attributes\": [\n        \"<string>\"\n      ]\n    }\n  ],\n  \"limit\": 1000\n}"

response = http.request(request)
puts response.read_body

Response

200

{
  "values": [
    {
      "updatedDate": "2023-11-07T05:31:56Z",
      "dimensions": {
        "account": "<string>",
        "accountName": "<string>",
        "accountId": "<string>",
        "parentAccountCode": "<string>",
        "parentAccountName": "<string>",
        "parentAccountId": "<string>",
        "childAccountId": "<string>",
        "description": "<string>",
        "productName": "<string>",
        "quantityUnit": "<string>",
        "subtotalUnit": "<string>",
        "convertedSubtotalUnit": "<string>",
        "billId": "<string>",
        "externalInvoiceReference": "<string>",
        "commitmentId": "<string>",
        "billLineItemId": "<string>"
      },
      "measures": {
        "convertedSubtotal": 123,
        "subtotal": 123,
        "version": 123,
        "conversionRate": 123,
        "quantity": 123,
        "units": 123
      },
      "billDetails": {
        "day": 123,
        "week": "<string>",
        "year": 123,
        "month": "<string>",
        "locked": "<string>",
        "status": "<string>",
        "dueDate": "<string>",
        "startDate": "<string>",
        "endDate": "<string>",
        "servicePeriodStartDate": "<string>",
        "servicePeriodEndDate": "<string>",
        "billDate": "<string>",
        "timezone": "<string>",
        "yearMonth": "<string>",
        "billCurrency": "<string>",
        "billingFrequency": "<string>"
      }
    }
  ]
}

Error Responses

{
  "message": "<string>"
}
{
  "message": "<string>"
}